Coin: SbVec3f Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Protected Attributes | Related Symbols | List of all members
SbVec3f Class Reference
Base Classes

The SbVec3f class is a 3 dimensional vector with floating point coordinates. More...

`#include <Inventor/SbVec3f.h>`

Inheritance diagram for SbVec3f:

## Public Member Functions
| SbVec3f (void)
| SbVec3f (const float v[3])
| SbVec3f (float x, float y, float z)
| SbVec3f (const SbVec3d &v)
| SbVec3f (const SbVec3b &v)
| SbVec3f (const SbVec3s &v)
| SbVec3f (const SbVec3i32 &v)
| SbVec3f (const SbPlane &p0, const SbPlane &p1, const SbPlane &p2)
SbVec3f & | setValue (const float v[3])
SbVec3f & | setValue (float x, float y, float z)
SbVec3f & | setValue (const SbVec3f &barycentric, const SbVec3f &v0, const SbVec3f &v1, const SbVec3f &v2)
SbVec3f & | setValue (const SbVec3d &v)
SbVec3f & | setValue (const SbVec3b &v)
SbVec3f & | setValue (const SbVec3s &v)
SbVec3f & | setValue (const SbVec3i32 &v)
const float * | getValue (void) const
void | getValue (float &x, float &y, float &z) const
float & | operator[] (int i)
const float & | operator[] (int i) const
SbBool | equals (const SbVec3f &v, float tolerance) const
SbVec3f | cross (const SbVec3f &v) const
float | dot (const SbVec3f &v) const
SbVec3f | getClosestAxis (void) const
float | length (void) const
float | sqrLength (void) const
float | normalize (void)
void | negate (void)
SbVec3f & | operator*= (float d)
SbVec3f & | operator/= (float d)
SbVec3f & | operator+= (const SbVec3f &v)
SbVec3f & | operator-= (const SbVec3f &v)
SbVec3f | operator- (void) const
SbString | toString () const
SbBool | fromString (const SbString &str)
void | print (FILE *fp) const

## Protected Attributes
float | vec [3]

## Related Symbols
(Note that these are not member symbols.)
SbVec3f | operator* (const SbVec3f &v, float d)
SbVec3f | operator* (float d, const SbVec3f &v)
SbVec3f | operator/ (const SbVec3f &v, float d)
SbVec3f | operator+ (const SbVec3f &v1, const SbVec3f &v2)
SbVec3f | operator- (const SbVec3f &v1, const SbVec3f &v2)
int | operator== (const SbVec3f &v1, const SbVec3f &v2)
int | operator!= (const SbVec3f &v1, const SbVec3f &v2)

## Detailed Description

The SbVec3f class is a 3 dimensional vector with floating point coordinates.

This vector class is used by many other classes in Coin. It provides storage for a 3 dimensional vector as well as simple floating point arithmetic operations.

See also
  SbVec2s, SbVec2f, SbVec2d, SbVec3s, SbVec3d, SbVec4f, SbVec4d.

## Constructor & Destructor Documentation

## ◆ SbVec3f() [1/8]

SbVec3f::SbVec3f | ( | void |  | ) |
| inline

The default constructor does nothing. The vector coordinates will be uninitialized until you do a setValue() call.

## ◆ SbVec3f() [2/8]

SbVec3f::SbVec3f | ( | const float | v[3] | ) |
| inline

Constructs an SbVec3f instance with initial values from v.

## ◆ SbVec3f() [3/8]

SbVec3f::SbVec3f | ( | float | x,
|  | float | y,
|  | float | z )
| inline

Constructs an SbVec3f instance with the initial vector endpoint set to <x,y,z>.

## ◆ SbVec3f() [4/8]

SbVec3f::SbVec3f | ( | const SbVec3d & | v | ) |
| inlineexplicit

Constructs an SbVec3f instance from an SbVec3d instance.

## ◆ SbVec3f() [5/8]

SbVec3f::SbVec3f | ( | const SbVec3b & | v | ) |
| inlineexplicit

Constructs an SbVec3f instance from an SbVec3b instance.

Since
  Coin 2.5

## ◆ SbVec3f() [6/8]

SbVec3f::SbVec3f | ( | const SbVec3s & | v | ) |
| inlineexplicit

Constructs an SbVec3f instance from an SbVec3s instance.

Since
  Coin 2.5

## ◆ SbVec3f() [7/8]

SbVec3f::SbVec3f | ( | const SbVec3i32 & | v | ) |
| inlineexplicit

Constructs an SbVec3f instance from an SbVec3i32 instance.

Since
  Coin 2.5

## ◆ SbVec3f() [8/8]

SbVec3f::SbVec3f | ( | const SbPlane & | p0,
|  | const SbPlane & | p1,
|  | const SbPlane & | p2 )

Constructs an SbVec3f instance by combining the three given planes. None of the planes should be parallel to any of the other two, otherwise a divide by zero error will occur.

## Member Function Documentation

## ◆ setValue() [1/7]

SbVec3f & SbVec3f::setValue | ( | const float | v[3] | ) |
| inline

Set new coordinates for the vector from v. Returns reference to self.

See also
  getValue().

## ◆ setValue() [2/7]

SbVec3f & SbVec3f::setValue | ( | float | x,
|  | float | y,
|  | float | z )
| inline

Set new coordinates for the vector. Returns reference to self.

See also
  getValue().

## ◆ setValue() [3/7]

SbVec3f & SbVec3f::setValue | ( | const SbVec3f & | barycentric,
|  | const SbVec3f & | v0,
|  | const SbVec3f & | v1,
|  | const SbVec3f & | v2 )

Set this vector to be the average of v0, v1 and v2. The vector components are weighted by the barycentric vector.

See also
  getValue().

## ◆ setValue() [4/7]

SbVec3f & SbVec3f::setValue | ( | const SbVec3d & | v | ) |

Sets this vector to the double precision vector v, converting the vector to a single precision vector.

This is a Coin extension.

Since
  Coin 2.0

## ◆ setValue() [5/7]

SbVec3f & SbVec3f::setValue | ( | const SbVec3b & | v | ) |

Since
  Coin 2.5

See also
  getValue()

## ◆ setValue() [6/7]

SbVec3f & SbVec3f::setValue | ( | const SbVec3s & | v | ) |

Since
  Coin 2.5

See also
  getValue()

## ◆ setValue() [7/7]

SbVec3f & SbVec3f::setValue | ( | const SbVec3i32 & | v | ) |

Since
  Coin 2.5

See also
  getValue()

## ◆ getValue() [1/2]

const float * SbVec3f::getValue | ( | void |  | ) | const
| inline

Returns a pointer to an array of three floats containing the x, y and z coordinates of the vector.

See also
  setValue().

## ◆ getValue() [2/2]

void SbVec3f::getValue | ( | float & | x,
|  | float & | y,
|  | float & | z ) const
| inline

Returns the x, y and z coordinates of the vector.

See also
  setValue().

## ◆ operator[]() [1/2]

float & SbVec3f::operator[] | ( | int | i | ) |
| inline

Index operator. Returns modifiable x, y or z coordinate of vector.

See also
  getValue() and setValue().

## ◆ operator[]() [2/2]

const float & SbVec3f::operator[] | ( | int | i | ) | const
| inline

Index operator. Returns x, y or z coordinate of vector.

See also
  getValue() and setValue().

## ◆ equals()

SbBool SbVec3f::equals | ( | const SbVec3f & | v,
|  | float | tolerance ) const

Compares the vector with v and returns `TRUE` if the distance between the vectors is smaller or equal to the square root of tolerance.

## ◆ cross()

SbVec3f SbVec3f::cross | ( | const SbVec3f & | v | ) | const

Returns the result of taking the cross product of this vector and v.

## ◆ dot()

float SbVec3f::dot | ( | const SbVec3f & | v | ) | const
| inline

Calculates and returns the result of taking the dot product of this vector and v.

## ◆ getClosestAxis()

SbVec3f SbVec3f::getClosestAxis | ( | void |  | ) | const

Return the vector representing the principal axis closest to this vector.

## ◆ length()

float SbVec3f::length | ( | void |  | ) | const

Return length of vector.

## ◆ sqrLength()

float SbVec3f::sqrLength | ( | void |  | ) | const
| inline

Returns the squared length of the vector.

## ◆ normalize()

float SbVec3f::normalize | ( | void |  | ) |

Normalize the vector to unit length. Return value is the original length of the vector before normalization.

If the vector is the null vector, no attempt at normalization will be done. If the Coin library was built in a debug version, and the COIN_DEBUG_NORMALIZE environment variable is set, this error message will then be shown:

      Coin warning in SbVec3f::normalize(): The length of the vector
      should be > 0.0f to be able to normalize.

We've made it possible for Coin to spit out a warning when an attempt at normalizing a null-vector is made, as that seems to sometimes be a symptom caused by some graver error somewhere else – either an internal error in Coin code, a programming error in application code, or an error in an input file (like for instance invalid polygon specifications).

If you run into bugs/problems with your application or with Coin, it could be a good idea to set COIN_DEBUG_NORMALIZE=1, and then restart the application to see if you get any warnings from normalize().

If this happens, you should run the application in a debugger and see how the call-stack backtrace looks when it hits. An easy way of getting a debugger break at the warning spot is to set the following debugging environment variable which will make the code assert:

      COIN_DEBUG_BREAK="SbVec3f::normalize"

If you from the backtrace analysis strongly suspects an internal Coin bug, please report the call-stack to us at coin-.nosp@m.supp.nosp@m.ort@c.nosp@m.oin3.nosp@m.d.org and we'll look into it. Example code that triggers the bug would then also be very helpful.

A note for developers porting code from SGI or TGS Inventor to Coin: those Inventor implementations are more slack about detecting and giving out warning messages upon API misuses, and you may suddenly have gotten this warning with Coin without seeing any indication of an error with SGI/TGS Inventor. This does not necessarily mean that it is a bug in Coin – it is much more likely that you are getting a warning as an indication of API misuse or import file errors which were just not detected and/or reported with those Inventor implementations.

## ◆ negate()

void SbVec3f::negate | ( | void |  | ) |
| inline

Negate the vector (i.e. point it in the opposite direction).

## ◆ operator*=()

SbVec3f & SbVec3f::operator*= | ( | float | d | ) |
| inline

Multiply components of vector with scalar value d. Returns reference to self.

## ◆ operator/=()

SbVec3f & SbVec3f::operator/= | ( | float | d | ) |
| inline

Divides components of vector with scalar value d. Returns reference to self.

## ◆ operator+=()

SbVec3f & SbVec3f::operator+= | ( | const SbVec3f & | u | ) |
| inline

Adds this vector and vector u. Returns reference to self.

## ◆ operator-=()

SbVec3f & SbVec3f::operator-= | ( | const SbVec3f & | u | ) |
| inline

Subtracts vector u from this vector. Returns reference to self.

## ◆ operator-()

SbVec3f SbVec3f::operator- | ( | void |  | ) | const
| inline

Non-destructive negation operator. Returns a new SbVec3f instance which points in the opposite direction of this vector.

See also
  negate().

## ◆ toString()

SbString SbVec3f::toString | ( |  | ) | const

Return a string representation of this object

## ◆ fromString()

SbBool SbVec3f::fromString | ( | const SbString & | str | ) |

Convert from a string representation, return whether this is a valid conversion

## ◆ print()

void SbVec3f::print | ( | FILE * | fp | ) | const

Dump the state of this object to the fp file stream. Only works in debug version of library, method does nothing in an optimized build.

## Friends And Related Symbol Documentation

## ◆ operator*() [1/2]

SbVec3f operator* | ( | const SbVec3f & | v,
|  | float | d )
| related

Returns an SbVec3f instance which is the components of vector v multiplied with d.

## ◆ operator*() [2/2]

SbVec3f operator* | ( | float | d,
|  | const SbVec3f & | v )
| related

Returns an SbVec3f instance which is the components of vector v multiplied with d.

## ◆ operator/()

SbVec3f operator/ | ( | const SbVec3f & | v,
|  | float | d )
| related

Returns an SbVec3f instance which is the components of vector v divided on the scalar factor d.

## ◆ operator+()

SbVec3f operator+ | ( | const SbVec3f & | v1,
|  | const SbVec3f & | v2 )
| related

Returns an SbVec3f instance which is the sum of vectors v1 and v2.

## ◆ operator-()

SbVec3f operator- | ( | const SbVec3f & | v1,
|  | const SbVec3f & | v2 )
| related

Returns an SbVec3f instance which is vector v2 subtracted from vector v1.

## ◆ operator==()

int operator== | ( | const SbVec3f & | v1,
|  | const SbVec3f & | v2 )
| related

Returns 1 if v1 and v2 are exactly equal, 0 otherwise.

See also
  equals().

## ◆ operator!=()

int operator!= | ( | const SbVec3f & | v1,
|  | const SbVec3f & | v2 )
| related

Returns 1 if v1 and v2 are not equal, 0 if they are equal.

See also
  equals().

## Member Data Documentation

## ◆ vec

float SbVec3f::vec[3]
| protected

The container for all values of this class.

The documentation for this class was generated from the following files:

- SbVec3f.h
- SbVec3f.cpp